%% define these parameters so the simulink model will run
%model

clear, clc
bo = 1.8276*10^7;
w=2*pi*3.175*10^2;
c=bo/w^2;
zeta=0;

%make the state space matrices
A=[0 1;-(w)^2 0;]; 
B=[0; bo];
C=[1 0];
D=[0; 0];

DD=[0];
sys=ss(A, B, C, DD);


%variables to define the control
% xl=.35*c; 
x1Tol = .001*c;
xl=.1*c; 
T=1; %saturator limit
alpha=.5; %discount factor
% alpha=1; %discount factor
%slopes for the linearized region
k1=(c-xl)/(c*xl); 
k2=sqrt(2*c*alpha*xl-alpha*xl^2)/(alpha*w*c*xl);
x2_bound=10*bo/w;


%initial condition
Xo=[2*c, 0];

trun=2*pi/w;
step_sz=.00000006;
trun = ceil(trun/step_sz)*step_sz;
% I want to plot the switching curve so run the function
%%to run a function to get x1, x2 for switching curves
[curves_ptosx1, curves_ptosx2, curves_optx1, curves_optx2]=switching_curves_comp_func_plus4(c, w, bo, alpha, xl, Xo);
x1=curves_ptosx1;
x2=curves_ptosx2;

[a, k]= min( abs(curves_optx1+2*c));
[a, l]= min( abs(abs(curves_optx1)-2*c));
n=length(curves_optx1);

curves_optx1_neg=curves_optx1(1:k);
curves_optx2_neg=curves_optx2(1:k);

curves_optx1_pos=curves_optx1(l:n);
curves_optx2_pos=curves_optx2(l:n);


% create saturator bounds
for i=1:length(x1)
if( abs(x1(i)) <= 2*c & abs(x1(i)) > xl)
    Fptos= sign( x1(i) ) *( w*sqrt(2*c*alpha*abs(x1(i)) -alpha*x1(i)^2) -1/k2);
%       control=-sat( k2*(Fptos +u(2)), T);
    x2_upper(i)=-(-1/k2 + real(Fptos));
    x2_lower(i)= -(1/k2 + real(Fptos));
 elseif(abs(x1(i)) <xl)
     Fptos=(k1/k2)*x1(i);
%       control=sat(-k1*u(1) -k2*u(2), T );
%         control=-sat( k2*(Fptos +u(2)), T);
      x2_upper(i)=-(-1/k2 + real(Fptos));
      x2_lower(i)=-(1/k2 + real(Fptos));
end




end

%

x1s=([.4*c, 1.2*c, 1.8*c]);
n=length(x1s);
%%from the LHS
for i=1:n
    Xo=[x1s(i), 0];
    sim('simulink_models/ptos_flex');
    x1prox_l(:,i)=xout_ptos(:,1);
    x2prox_l(:,i)=xout_ptos(:,2);
    tout_prox_l(:,i)=tout_ptos;
    u_all_l(:, i)=control_flex_ptos;
    
    

    

end
%
t=0:step_sz:2*pi/w;
u=sin(t);

Xo=[8.261 -758.3];
[y, t, x_four]=lsim(sys, u, t, Xo);
[a, k]=min(x_four(:,2));
x_four=x_four(1:k,:);

trun=2.5*pi/w;
trun = ceil(trun/step_sz)*step_sz;
Xo=[1.99*c, 3000];


Xo1 = 2*c;

Xo2 = 2/k2;
Xo= [Xo1, Xo2];
sim('simulink_models/ptos_flex');
x1prox_damn=xout_ptos(:,1);
x2prox_damn=xout_ptos(:,2);


Xo=[5.358 -3491];
Xo=[8.665 4229];
[y, t, x_five]=lsim(sys, u, t, Xo);
[a, k]=min(x_five(:,2));
x_five=x_five(1:k,:);




clf
% For Normal Figures
height=1.3/1.618; % width/golden ratio
width=1;

% For Wide Figures
% height=1.0/1.618; % width/golden ratio
xpos=1000; 
ypos=500;
scale=450; % 3.13 inches
figure(1); % Create Figure

axes('FontName','Times New Roman') % Set axis font style
box('on'); % Define box around whole figure
set(gcf,'Position',[xpos ypos scale*width scale*height]) % Set figure format

hold on;

pcurves=plot(curves_ptosx1, curves_ptosx2);  %%CENTER PTOS CURVE

m=length(x1);
[a, j]=min(abs(x1));  %% x1 = 0
[a, k]=min(abs( abs(x1(1:j))-c)); %% x1=c
[a, l]=min(abs( abs(x1(j:length(x1))) -c));
[a, n]=min(abs( abs(x1(j:length(x1))) -xl));
n=n+j;
l=l+j;
%%%%% PLOT SHADING

ps2=plotshaded(x1(k:l), [x2_upper(k:l); x2_lower(k:l)], 'k', .50);
ps3=plotshaded(x1(l:m), [x2_upper(l:m); x2_lower(l:m)], 'k', .2);

p1=plot(x1(j:n), x2_upper(j:n), 'm', 'linewidth', 2); %%AB
p2=plot(x1(j:n), x2_lower(j:n), 'k', 'linewidth', 2); %%DE
p3=plot(x1(n:m), x2_upper(n:m), 'c', 'linewidth', 2); %%BC
p4=plot(x1(n:l), x2_lower(n:l), 'linewidth', 2);      %%EF
p4.Color=[.87, .49, 0];
p5=plot(x1(l:m), x2_lower(l:m), 'b', 'linewidth', 2); %%FG
% hold on

p6=plot(curves_optx1(36740:37629), curves_optx2(36740:37629), 'r', 'linewidth', 1.5 );

h_bounded=plot(x1prox_l(:,1), x2prox_l(:,1) );
h_maybe=plot(x1prox_l(:,2), x2prox_l(:,2) );
h_exit    =plot(x1prox_l(:,3), x2prox_l(:,3) );
h_damn= plot(x1prox_damn, x2prox_damn );


[~, j]=min(x2prox_l(:,1));
[~, k]=min(x2prox_l(:,2));
[~, l]=min(x2prox_l(:,3));
[~, m]=min(x2prox_damn);


%%%%%%%plot c and xl
% h_c=plot([c,c], [-2*bo/w,2*bo/w])
h_xl=plot([xl,xl], [-2*bo/w,2*bo/w], '--g', 'LineWidth', 2);
h_c=plot([c,c], [-2*bo/w,2*bo/w], '--b', 'LineWidth', 2);

%%%%%%%%%%%%%%%%%%
%%%%%% BUILD THE AXES
ax=gca;
set(ax, 'XTick', [0:c:2*c]);
set(ax, 'YTick', [-bo/w:bo/w:bo/w]);
set(ax, 'YTickLabel', [])

xlim([0, 2.2*c]);
ylim([-1.3*bo/w, .8*bo/w]);



yticks=get(ax, 'ytick');
xticks=get(ax, 'xtick');
set(ax, 'XTickLabel', [])

my_yticks={'$\frac{-b_o}{w}$','$0$'};
my_xticks={'0','$c$','$2c$'};
axs=axis;
HorizontalOffset=-.2;
VertOffset=1000;

for i=1:length(yticks)-1
  text(axs(1)+HorizontalOffset, yticks(i),my_yticks(i),'HorizontalAlignment','Right','interpreter', 'latex', 'FontSize', 14);   

end

for i=1:length(xticks)
  text(xticks(i)+.2, axs(3)-VertOffset, my_xticks(i),'HorizontalAlignment','Right','interpreter', 'latex', 'FontSize',12);   

end

grid
    

%%%% set plot attributes


set(h_bounded,'LineWidth',1.5,'LineStyle','--', 'Color', [.87, .49, 0]);  %ideal trajectory
set(h_maybe,'LineWidth',1.5,'LineStyle','--', 'Color', 'k');
set(h_exit,'LineWidth',1.5,'LineStyle','--', 'Color', 'r'); %%exiting traj
set(h_damn, 'LineWidth',1.5,'LineStyle','--', 'Color', [0 .5 0]); %%exits vert line 


% Create xlabel
hxlab=xlabel('$x_1$','FontSize',18,'FontName','Times New Roman','FontAngle','italic');

% Create ylabel
hylab=ylabel('$x_2$','FontSize',18,'FontName','Times New Roman','FontAngle','italic','rot',0);


set(hylab, 'Units', 'Normalized', 'Position', [-.1, 0.5, 0]);
set(hxlab, 'Units', 'Normalized', 'Position', [.5, -.051, 0]);
set(hxlab, 'interpreter', 'latex');
set(hylab, 'interpreter', 'latex');


%%%%%%%%%%   legend

hleg1=legend([h_bounded, h_maybe, h_exit, h_damn, p6],'trajectory 1', 'trajectory 2', 'trajectory 3', 'trajectory 4', '$-f_{to}$');

set(hleg1,  'FontSize', 9.8);
set(hleg1,'Interpreter','latex');
set(hleg1,'Position',[0.4093 0.6368 0.3896 0.2842]);
set(hleg1,'box','on');

plot([7.88,7.88],[-4542, -10500], 'k', 'LineWidth', 1)
plot([1.348,1.348],[-4542, -10500], 'k', 'LineWidth', 1)
plot([1.148,8.05],[-10000, -10000], 'k', 'LineWidth', 1)
plot([1.148+6.532, 1.548+6.532], [-9500, -10500], 'k', 'LineWidth', 1)
plot([1.148, 1.548], [-9500, -10500], 'k', 'LineWidth', 1)

text(.06, .025, '$x_{\ell}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)
text(.47, .02, '$c$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)
text(.7, 0.45, '$\mathcal{T}$', 'interpreter', 'latex', 'Units', 'Normalized', 'FontSize', 14)
text(.2, 0.43, '$\mathcal{B}$', 'interpreter', 'latex','Units', 'Normalized', 'FontSize', 14)
text(.55, 0.05, '$c+\beta$', 'interpreter', 'latex','Units', 'Normalized', 'FontSize', 14)
text(.2, 0.05, '$c-\beta$', 'interpreter', 'latex','Units', 'Normalized', 'FontSize', 14)
text(.2, .95, '$\mathcal{U}^-$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)
text(.9, .05, '$\mathcal{U}^+$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)

text(.41, .47, 'H', 'Units', 'Normalized', 'FontSize', 12)
text(.41, .24, 'F', 'Units', 'Normalized', 'FontSize', 12)
text(.92, .75, 'C', 'Units', 'Normalized', 'FontSize', 12)
text(.92, .59, 'G', 'Units', 'Normalized', 'FontSize', 12)




% text(.06, .05, '$mathcal{T}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)
% text(.06, .05, '$mathcal{T}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)
% text(.06, .05, '$mathcal{T}$', 'Units', 'Normalized', 'interpreter', 'latex', 'FontSize', 12)


